from z3 import *

# convert to CNF example
# input is arbitrary formula
x, y, z = Ints("x y z")

g1 = Goal()

P1 = Implies( (x > 0), (y >0) )
P2 = Implies( (x > 0), (y >0) )
g1.add( And(P1,P2) )
g1.add(Or (And ( (x == 0), (y == 0) ), Or( (x == 1), (y == 1)), And( (x == 2), (y == 2) ) ) )

P3 = Implies( (x > 0), (y == x))
P4 = Implies( Not(x > 0), (y == (x - 1)))

g1.add( And(P3, P4) )
g1.add(z > If( (x > 0), (- x), x) )



#'(then (! simplify :elim-and true) elim-term-ite tseitin-cnf)'
tac1 = Then( With(Tactic('simplify'), elim_and=True), Tactic('elim-term-ite'), Tactic('tseitin-cnf'))

print g1 # before CNF
print tac1(g1) # in CNF

#(echo "Trying again without using distributivity...")
#(apply (then (! simplify :elim-and true) elim-term-ite (! tseitin-cnf :distributivity false)))

tac2 = Then( With(Tactic('simplify'), elim_and=True), Tactic('elim-term-ite'), With(Tactic('tseitin-cnf'), distributivity=False))
print tac2(g1) # in CNF without distributivity


# convert to DNF (assuming input is CNF)
t1, t2, t3 = Ints("t1 t2 t3")

g2 = Goal()
g2.add( And( Or( t1 >= 2, t2 >= 3 ),
             t3 >= 1,
             Or( t1 <= 4, t2 <= 5) ) )

#(apply (then simplify (repeat (or-else split-clause skip))))

tac3 = Then( Tactic('simplify'), Repeat(OrElse(Tactic('split-clause'), Tactic('skip'))))

print g2
print tac3(g2)

print tac3( tac2(g1).as_expr() ) # convert to CNF and then to DNF
