from z3 import *

# http://rise4fun.com/Z3Py/wUR6

# Difference between unsat, sat, and inconsistent

x, y = Reals('x y')

p1 = x >= 1
p2 = x < 0
p3 = 1 > 0
p4 = True
p5 = 1 == 0
p6 = False
p7 = 1 < 0

g = Goal()

print "p1"
g.add(p1)
print g.inconsistent() # False
print "\n"

print "p2"
g.add(p2)
print g
print g.inconsistent() # False: still consistent, but note that the set of assertions is unsatisfiable now
print "\n"

print "p3"
g.add(p3)
print g.inconsistent() # False
print "\n"


print "p4"
g.add(p4)
print g.inconsistent() # False
print "\n"


print "p5"
g.add(p5)
print g.inconsistent() # True since 1 == 0 is False, and we've asserted false'
print "\n"

g = Goal()

print "p6"
g.add(p6)
print g.inconsistent() # True since we've asserted False
print "\n"

g = Goal()

print "p7"
g.add(p7)
print g.inconsistent() # True since 1 < 0 is False
print "\n"